## h5z-zfp 1.1.0+git20221021

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

# Fail immediately if not using an out-of-source build
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are not supported.  Please create a build directory "
    "separate from the source directory")
endif ()

#------------------------------------------------------------------------------#
# Parse version number from H5Zzfp_version.h
#------------------------------------------------------------------------------#
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/H5Zzfp_version.h" H5Z_ZFP_H REGEX "^\#define H5Z_FILTER_ZFP_VERSION_MAJOR")
string(REGEX REPLACE "^.*MAJOR " "" H5Z_ZFP_VERSION_MAJOR "${H5Z_ZFP_H}")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/H5Zzfp_version.h" H5Z_ZFP_H REGEX "^\#define H5Z_FILTER_ZFP_VERSION_MINOR")
string(REGEX REPLACE "^.*MINOR " "" H5Z_ZFP_VERSION_MINOR "${H5Z_ZFP_H}")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/H5Zzfp_version.h" H5Z_ZFP_H REGEX "^\#define H5Z_FILTER_ZFP_VERSION_PATCH")
string(REGEX REPLACE "^.*PATCH " "" H5Z_ZFP_VERSION_PATCH "${H5Z_ZFP_H}")
set(H5Z_ZFP_VERSION "${H5Z_ZFP_VERSION_MAJOR}.${H5Z_ZFP_VERSION_MINOR}.${H5Z_ZFP_VERSION_PATCH}")

project(H5Z_ZFP VERSION ${H5Z_ZFP_VERSION} LANGUAGES C)

#------------------------------------------------------------------------------#
# Compile options.
#------------------------------------------------------------------------------#
option(FORTRAN_INTERFACE "Enable the Fortran interface" ON)
if (FORTRAN_INTERFACE)
  enable_language(Fortran)
endif ()

#------------------------------------------------------------------------------#
# Some boilerplate to setup nice output directories
#------------------------------------------------------------------------------#
set(CMAKE_INSTALL_INCLUDEDIR include)
set(CMAKE_INSTALL_CMAKEDIR lib/cmake/h5z_zfp)

#------------------------------------------------------------------------------#
# Required packages
#------------------------------------------------------------------------------#
# Find HDF5, relies on HDF5_DIR or HDF5_ROOT being set in environment.
set(COMPONENTS C)
if (FORTRAN_INTERFACE)
  list(APPEND COMPONENTS Fortran)
endif ()
find_package(HDF5 REQUIRED COMPONENTS ${COMPONENTS})

# Find ZFP, relies on ZFP_DIR or ZFP_ROOT being set in environment.
find_package(ZFP REQUIRED CONFIG)

#------------------------------------------------------------------------------#
# Add source
#------------------------------------------------------------------------------#
add_subdirectory(${CMAKE_SOURCE_DIR}/src)

#------------------------------------------------------------------------------#
# Packaging
#------------------------------------------------------------------------------#
# Install h5z_zfp-config.cmake and h5z_zfp-config-version.cmake
set(H5Z_ZFP_CONFIG_IN  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/h5z_zfp-config.cmake.in)
set(H5Z_ZFP_CONFIG_OUT ${CMAKE_CURRENT_BINARY_DIR}/cmake/h5z_zfp-config.cmake)
configure_file(${H5Z_ZFP_CONFIG_IN} ${H5Z_ZFP_CONFIG_OUT} @ONLY)
set(H5Z_ZFP_CONFIG_VERSION_IN  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/h5z_zfp-config-version.cmake.in)
set(H5Z_ZFP_CONFIG_VERSION_OUT ${CMAKE_CURRENT_BINARY_DIR}/cmake/h5z_zfp-config-version.cmake)
configure_file(${H5Z_ZFP_CONFIG_VERSION_IN} ${H5Z_ZFP_CONFIG_VERSION_OUT} @ONLY)
install(FILES ${H5Z_ZFP_CONFIG_OUT}
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR})
install(FILES ${H5Z_ZFP_CONFIG_VERSION_OUT}
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR})

=== Makefile ===
include config.make

.PHONY: help all clean dist install

help:
	@echo ""
	@echo ""
	@echo ""
	@echo "             This is H5Z-ZFP version $(H5Z_ZFP_VERSINFO)."
	@echo "See http://h5z-zfp.readthedocs.io/en/latest/ file for more info."
	@echo ""
	@echo "Typical make command is..."
	@echo ""
	@echo "    make CC=<C-compiler> HDF5_HOME=<path> ZFP_HOME=<path> PREFIX=<path> all"
	@echo ""
	@echo "where <path> is a dir whose children are include/lib/bin subdirs."
	@echo "HDF5_HOME can also be specified by the HDF5 include directory,"
	@echo "library directory and bin directory separated by commas, i.e. HDF5_HOME=INC,LIB,BIN"
	@echo "Standard make variables (e.g. CFLAGS, LD, etc.) can be set as usual."
	@echo "Optionally, add FC=<fortran-compiler> to include Fortran support and tests."
	@echo ""
	@echo "Available make targets are..."
	@echo "    all - build everything"
	@echo "    check - all + run tests"
	@echo "    install - install compiled components"
	@echo "    clean - clean away all derived targets"
	@echo "    dist - create distribution tarfile"

all:
	cd src; $(MAKE) $(MAKEVARS) $@

check: all install
	cd test; $(MAKE) $(MAKEVARS) $@

install:
	cd src; $(MAKE) $(MAKEVARS) $@

clean:
	rm -f H5Z-ZFP-$(H5Z_ZFP_VERSINFO).tar.gz
	cd src; $(MAKE) $(MAKEVARS) $@
	cd test; $(MAKE) $(MAKEVARS) $@

dist:	clean
	rm -rf H5Z-ZFP-$(H5Z_ZFP_VERSINFO) H5Z-ZFP-$(H5Z_ZFP_VERSINFO).tar.gz; \
	mkdir H5Z-ZFP-$(H5Z_ZFP_VERSINFO); \
	tar cf - --exclude ".git*" --exclude H5Z-ZFP-$(H5Z_ZFP_VERSINFO) . | tar xf - -C H5Z-ZFP-$(H5Z_ZFP_VERSINFO); \
	tar cvf - H5Z-ZFP-$(H5Z_ZFP_VERSINFO) | gzip --best > H5Z-ZFP-$(H5Z_ZFP_VERSINFO).tar.gz; \
	rm -rf H5Z-ZFP-$(H5Z_ZFP_VERSINFO);

=== src/CMakeLists.txt ===
# Define headers.
set(h5z_zfp_headers
  H5Zzfp.h H5Zzfp_lib.h H5Zzfp_plugin.h H5Zzfp_props.h H5Zzfp_version.h)

#------------------------------------------------------------------------------#
# Static library
#------------------------------------------------------------------------------#
# Define source
set(h5z_zfp_lib_source
  ${h5z_zfp_headers}
  H5Zzfp_props_private.h
  H5Zzfp.c H5Zzfp_props.c)

if (FORTRAN_INTERFACE)
  list(APPEND h5z_zfp_lib_source H5Zzfp_props_f.F90)
endif ()

add_library(h5z_zfp_static STATIC ${h5z_zfp_lib_source})
target_compile_definitions(h5z_zfp_static PRIVATE H5Z_ZFP_AS_LIB)
target_include_directories(h5z_zfp_static
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    ${HDF5_INCLUDE_DIRS})
target_link_libraries(h5z_zfp_static PUBLIC zfp::zfp ${HDF5_LIBRARIES})
set_target_properties(h5z_zfp_static PROPERTIES POSITION_INDEPENDENT_CODE 1)
set_target_properties(h5z_zfp_static PROPERTIES OUTPUT_NAME h5zzfp)
install(TARGETS h5z_zfp_static
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)

#------------------------------------------------------------------------------#
# Shared library
#------------------------------------------------------------------------------#
# Define source
set(h5z_zfp_plugin_source
  ${h5z_zfp_headers}
  H5Zzfp.c)

add_library(h5z_zfp_shared SHARED ${h5z_zfp_plugin_source})
target_include_directories(h5z_zfp_shared
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    ${HDF5_INCLUDE_DIRS})
target_link_libraries(h5z_zfp_shared PUBLIC zfp::zfp ${HDF5_LIBRARIES})
set_target_properties(h5z_zfp_shared PROPERTIES OUTPUT_NAME h5zzfp)
install(TARGETS h5z_zfp_shared
  ARCHIVE DESTINATION plugin
  LIBRARY DESTINATION plugin)

#------------------------------------------------------------------------------#
# Install header and module files.
#------------------------------------------------------------------------------#
install(FILES ${h5z_zfp_headers}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (FORTRAN_INTERFACE)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/h5zzfp_props_f.mod
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif ()

=== src/Makefile ===
include ../config.make

.PHONY: all lib clean

# The filter compiled to be used as a plugin
H5Zzfp_plugin.o: H5Zzfp.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# The filter compiled to be used as a library
H5Zzfp_lib.o: H5Zzfp.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_AS_LIB $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# The plugin shared lib (HDF5 expects it to be named "lib*.{so,dylib}"
plugin/libh5zzfp.$(SOEXT): H5Zzfp_plugin.o
	rm -rf plugin
	mkdir plugin
	$(CC) $< $(SHFLAG) -o plugin/libh5zzfp.$(SOEXT) \
	    $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) \
	    -L$(ZFP_LIB) -L$(HDF5_LIB) -lhdf5 -lzfp $(LDFLAGS)

# Alias target for filter plugin
plugin: plugin/libh5zzfp.$(SOEXT)

# C language properties interface
H5Zzfp_props.o: H5Zzfp_props.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# Fortran language properties interface
H5Zzfp_props_f.o H5Zzfp_props_f.mod: H5Zzfp_props_f.F90
	$(FC) -c $< -o $@ $(FCFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# The filter member of the filter library
libh5zzfp.a(H5Zzfp_lib.o): H5Zzfp_lib.o
	$(AR) cr libh5zzfp.a $<

# The C properties interface member of the filter library
libh5zzfp.a(H5Zzfp_props.o): H5Zzfp_props.o
	$(AR) cr libh5zzfp.a $<

# The Fortran properties interface member of the filter library
libh5zzfp.a(H5Zzfp_props_f.o): H5Zzfp_props_f.o
	$(AR) cr libh5zzfp.a $<

# Alias target for filter library, conditionally includes Fortran
LIBOBJ = libh5zzfp.a(H5Zzfp_lib.o) libh5zzfp.a(H5Zzfp_props.o)
ifneq ($(FC),)
LIBOBJ += libh5zzfp.a(H5Zzfp_props_f.o)
endif
lib: $(LIBOBJ)

all: lib plugin

install: all
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/{plugin,include,lib}
	$(INSTALL) plugin/libh5zzfp.$(SOEXT) $(DESTDIR)$(PREFIX)/plugin
	$(INSTALL) libh5zzfp.a $(DESTDIR)$(PREFIX)/lib
	$(INSTALL) -m 644 H5Zzfp.h H5Zzfp_lib.h H5Zzfp_plugin.h H5Zzfp_version.h H5Zzfp_props.h $(DESTDIR)$(PREFIX)/include
ifneq ($(FC),)
	$(INSTALL) -m 644 *.[mM][oO][dD] $(DESTDIR)$(PREFIX)/include
endif

clean:
	rm -rf plugin
	rm -f libh5zzfp.a *.o *.[mM][oO][dD]
	rm -f *.gcno *.gcda *.gcov
	rm -f H5Zzfp_props_f.mod

=== test/Makefile ===
include ../config.make

NO_COLOR=\033[0m
OK_COLOR=\033[32;01m
ERROR_COLOR=\033[31;01m
SKIP_COLOR=\033[0;34m
padlimit=60
padlength=60

ZFP_LIBS = -lzfp
ifeq ($(ZFP_HAS_CFP),1)
    ZFP_LIBS += -lcfp -lstdc++
endif

.PHONY: lib plugin check patch clean

patch:
	@echo "If using HDF5-1.8, make sure you have patched repack"

plugin:
	cd ../src; $(MAKE) $(MAKEVARS) $@

lib:
	cd ../src; $(MAKE) $(MAKEVARS) $@

test_write_plugin.o: test_write.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_USE_PLUGIN -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_write_lib.o: test_write.c
	$(CC) -c $< -o $@ $(CFLAGS) -DZFP_HAS_CFP=$(ZFP_HAS_CFP) -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_write_plugin: test_write_plugin.o plugin
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L$(HDF5_LIB) -L$(ZFP_LIB) -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_write_lib: test_write_lib.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_read_plugin.o: test_read.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_USE_PLUGIN $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_read_lib.o: test_read.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_read_plugin: test_read_plugin.o plugin
	$(CC) $< -o $@ $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L$(HDF5_LIB) -L$(ZFP_LIB) -lhdf5 $(ZFP_LIBS) $(LDFLAGS)

test_read_lib: test_read_lib.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) $(LDFLAGS)

test_error.o: test_error.c
	$(CC) -c $< -o $@ $(CFLAGS) -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_error: test_error.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

print_h5repack_farg: print_h5repack_farg.o
	$(CC) $< -o $@ $(LDFLAGS)

print_h5repack_farg.o: print_h5repack_farg.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(HDF5_INC)

ifneq ($(FC),) # Fortran Tests [

test_rw_fortran: test_rw_fortran.o lib
	$(FC) $(FCFLAGS) -o $@ $< $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5_fortran -lhdf5 $(ZFP_LIBS) $(LDFLAGS)

%.o:%.F90
	$(FC)  -o $@ -c $< $(FCFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)


# Note: The write-half of all the Fortran tests utilize the default and properties
# interface library to control the filter. The read-half uses the plugin.

test-default : test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
         x="./test_rw_fortran"; \
	 printf "$$x"; \
	 printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
         $$x 2>&1 1>/dev/null; \
         if [[ $$status -ne 0 ]]; then \
	     printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	     touch check-failed; \
	     exit 0; \
          fi; \
	  printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \

# Decrease bit rate and confirm compression ratio increases
test-rate-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for r in 32 16 8 4; do\
            x="./test_rw_fortran zfpmode 1 rate $$r"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    expected_ratio=$$(expr 64 \/ $$r); \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed -p test_zfp_fortran.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DUMP*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed-plugin -p test_zfp_fortran.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DUMP*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \

# Increase accuracy and test absolute error tolerance is within accuracy
test-accuracy-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for a in 0.1 0.01 0.001 0.0001; do\
            x="./test_rw_fortran zfpmode 3 acc $$a write"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \

# Increase precision and confirm diff count for given tolerance drops
test-precision-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for p in 12 16 20 24; do\
            x="./test_rw_fortran zfpmode 2 prec $$p write"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original | grep 'differences found' | cut -d' ' -f1); \
	    if [[ $$ldiffcnt -ne 0 ]] && [[ $$diffcnt -gt $$ldiffcnt ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
		exit 0; \
	    fi; \
	    diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original | grep 'differences found' | cut -d' ' -f1); \
	    if [[ $$ldiffcnt -ne 0 ]] && [[ $$diffcnt -gt $$ldiffcnt ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
		exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	 done; \

# Ensure reversible gives bit-for-bit identical results
test-reversible-f: plugin test_rw_fortran
	@echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	x="./test_rw_fortran zfpmode 5 write"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	$$x >/dev/null 2>/dev/null; \
        status=$$?; \
        if [[ $$status -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    touch check-failed; \
            exit 0; \
         fi; \
	diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original | grep 'differences found' | cut -d' ' -f1); \
	if [[ $$diffcnt -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	    touch check-failed; \
	    exit 0; \
	fi; \
	diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original | grep 'differences found' | cut -d' ' -f1); \
	if [[ $$diffcnt -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	    touch check-failed; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n\n"; \

endif # ] ifneq ($(FC),)

# Decrease bit rate and confirm compression ratio increases
test-rate: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	for r in 32 16 8 4; do \
	    expected_ratio=$$(expr 64 \/ $$r); \
	    x="./test_write_plugin zfpmode=1 rate=$$r"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    env HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $$x 2>&1 1>/dev/null; \
            if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
            fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed -p test_zfp.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \
	x="Plugin rate tests"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
        if [[ $$failed -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"

# Increase accuracy and test absolute error tolerance is within accuracy
test-accuracy: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	for a in 0.1 0.01 0.001 0.0001; do\
	    x="./test_write_plugin zfpmode=3 acc=$$a"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    env HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $$x 2>&1 1>/dev/null; \
            if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp.h5 test_zfp.h5 compressed original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        echo "Plugin accuracy test failed for accuracy=$$a"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \
	x="Plugin accuracy tests"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
        if [[ $$failed -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"

# Increase precision and confirm diff count for given tolerance drops
test-precision: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	ldiffcnt=0; \
	for p in 12 16 20 24; do\

=== debian/changelog ===
h5z-zfp (1.1.0+git20221021-4) unstable; urgency=medium

  * Added Provides/Conflict/Replaces for the old name hdf5-plugin-zfp.
    Closes: #1030029
  * Use the new B-D architecture-is-little-endian instead of a long arch list

 -- Enrico Zini <enrico@debian.org>  Tue, 31 Jan 2023 16:36:21 +0100

h5z-zfp (1.1.0+git20221021-3) unstable; urgency=medium

  * Set Maintainer to debian-science-maintainers@lists.alioth.debian.org
    and uploaders to team+freexian@tracker.debian.org
  * Renamed binary package to hdf5-filter-plugin-zfp-serial to follow
    https://salsa.debian.org/science-team/h5f-packaging-guidelines
  * Added simple autopkgtest
  * Do not try to build on big-endian machines, due to
    https://github.com/LLNL/H5Z-ZFP/issues/95

 -- Enrico Zini <enrico@debian.org>  Sun, 29 Jan 2023 12:01:37 +0100

h5z-zfp (1.1.0+git20221021-2) unstable; urgency=medium

  * Marked documentation-only Build-Deps with <!nodoc>
  * Added README.Debian explaining the current absence of openmpi and static
    library support, and offering to work on it if someone can help with
    testing
  * Fixed Vcs-* headers to point to where code is packaged
  * Only ship the filter plugin, skip the static library for now (see
    README.Debian)

 -- Enrico Zini <enrico@debian.org>  Sun, 04 Dec 2022 10:45:44 +0100

h5z-zfp (1.1.0+git20221021-1) unstable; urgency=medium

  * Initial version. Closes: #1024358

 -- Enrico Zini <enrico@debian.org>  Tue, 22 Nov 2022 13:20:07 +0100

=== debian/control ===
Source: h5z-zfp
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Freexian Packaging Team <team+freexian@tracker.debian.org>
Build-Depends:
  architecture-is-little-endian,
  debhelper-compat (= 13), dh-fortran-mod (>= 0.11),
  pkg-config,
  libhdf5-dev, libhdf5-mpi-dev, mpi-default-dev,
  libzfp-dev, hdf5-tools,
  gfortran,
  dh-sequence-sphinxdoc <!nodoc>, python3-sphinx <!nodoc>
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/LLNL/H5Z-ZFP
Vcs-Git: https://salsa.debian.org/science-team/h5z-zfp.git
Vcs-Browser: https://salsa.debian.org/science-team/h5z-zfp

Package: hdf5-filter-plugin-zfp-serial
Provides: hdf5-plugin-zfp
Conflicts: hdf5-plugin-zfp
Replaces: hdf5-plugin-zfp
# h5z-zfp currently fails on big-endian machines. See: https://github.com/LLNL/H5Z-ZFP/issues/95
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${sphinxdoc:Depends}
Description: Compression plugin for the HDF5 library using ZFP compression
 H5Z-ZFP is a compression filter for HDF5 using the ZFP compression library,
 supporting lossy and lossless compression of floating point and integer data
 to meet bitrate, accuracy, and/or precision targets.

=== debian/tests/control ===
Test-Command: python3 -c 'import sys, h5py; sys.exit(not h5py.h5z.filter_avail(32013))'
Depends: python3, python3-h5py, @
Restrictions: allow-stderr

=== debian/watch ===
version=4 opts="searchmode=plain, \
filenamemangle=s/.+/v@ANY_VERSION@/@package@-$1.tar.gz/, \
dversionmangle=auto" \
https://api.github.com/repos/LLNL/H5Z-ZFP/releases \
https://api.github.com/repos/LLNL/H5Z-ZFP/tarball/v@ANY_VERSION@ \
debian uupdate
